#
# spec file for package joe (Version 3.7)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           joe
BuildRequires:  ncurses-devel
License:        GPLv2+
Group:          Productivity/Editors/Other
AutoReqProv:    on
Version:        3.7
Release:        4.4.1
Summary:        A Text Editor
Url:            http://sourceforge.net/projects/joe-editor
Source:         joe-%{version}.tar.bz2
Source1:        lang_additions.tar.bz2
Source2:        de.po
Patch:          joe-3.1-terminate_buffer.patch
Patch2:         joe-3.1-fix_isblanck_argument.patch
Patch3:         joe-3.3-warnings.patch
Patch5:         joe-activate_po.patch
Patch6:         joe-fr_trans.patch
Patch7:         joe-3.7-additional_key_mappings.patch
Patch8:         joe-3.7-spec_association.patch
Patch9:         joe-sigiot.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
JOE (Joe's Own Editor) is a freeware ASCII editor for UNIX. Joe is
similar to most IBM PC text editors. The keyboard combinations are
similar to WordStar[tm] and Turbo C. Some of Joe's features include:

-full support of termcap and terminfo (useful for device-independent
descriptions to control screen output) -optimized screen refresh like
GNU Emacs (Joe can even be used at 2400 baud) -easy installation with
all features for UNIX integration with vi: a marked block of text can
be filtered through a UNIX command and wherever JOE accepts a filename
parameter, the following can also be substituted:

!command\t\t:to redirect from or to another command

>>filename\t\t:to append onto an existing file

filename,start,size\t:to edit a part of a file or device

-\t\t\t:to use standard input/output

When JOE has several files opened at the same time, each file is
displayed in its own window. Additionally, JOE allows for shell windows
from which the output of the executed commands are saved in a buffer,
automatic filename completion (via TAB), help windows, undo and redo,
and search and replace using regular expressions.



Authors:
--------
    Joseph H. Allen <jhallen@world.std.com>
    
    Marek 'Marx' Grac <xgrac@fi.muni.cz>

%prep
%setup -q
%patch
%patch2
%patch3
%patch6
%patch7
%patch8
%patch9
gettextize -f
tar -xvf %{S:1}
%patch5
cp %{S:2} po

%build
autoreconf -fi
export CFLAGS="%{optflags} -W -Wno-unused"
./configure \
  --prefix=%{_prefix} \
  --mandir=%{_mandir} \
  --sysconfdir=%{_sysconfdir} \
  --docdir=%{_defaultdocdir}/%name
cd po
make update-po
make

%install
%makeinstall
#  prefix=%{buildroot}%{_prefix} \
#  mandir=%{buildroot}%{_mandir} \
#  sysconfdir=%{buildroot}%{_sysconfdir} \
#  docdir=%{buildroot}%{_defaultdocdir}/%name \
#  install
for i in jmacs jpico jstar rjoe; do
  ln -s joe.1.gz %{buildroot}%{_mandir}/man1/$i.1.gz
done

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc %{_defaultdocdir}/%{name}
%doc %{_mandir}/man1/*
%doc %{_mandir}/*/man1/*
%config %{_sysconfdir}/joe/*
%dir %{_sysconfdir}/joe
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/lang
%dir %{_mandir}/ru
%dir %{_mandir}/ru/man1
%{_bindir}/*
%{_datadir}/%{name}/charmaps
%{_datadir}/%{name}/syntax
%lang(de) %{_datadir}/%{name}/lang/de.mo
%lang(en) %{_datadir}/%{name}/lang/en@*.mo
%lang(fr) %{_datadir}/%{name}/lang/fr.mo
%lang(ru) %{_datadir}/%{name}/lang/ru.mo
%lang(uk) %{_datadir}/%{name}/lang/uk.mo

%changelog
* Sun Jan  3 2010 pth@novell.com
- Add patch from factory to fix SIGIOT in autoindent code (bnc#548327).
* Wed Feb 25 2009 pth@suse.de
- Fix typo in ftyperc (bnc#476435).
* Thu Jan 22 2009 pth@suse.de
- Remove obsolete patch
- Fix file list
- Split and rename joe-3.0-rc.patch, move syntax mapping from j*rc
  to ftyperc.
* Wed Jan 21 2009 pth@suse.de
- Use gettext autoconf macros and makefiles.
- Added complete germen translation.
- Update to 3.7
  Changes in 3.7:
  - backspace/DEL means 'n' in replace prompt for better emacs
    compatibility
  - Menus are now made up of macros instead of options.
    New commands:
  menu	Prompt for a menu to display with tab
  completion.
  mode	Prompt for an option to change with tab
  completion.
  Menus are defined in joerc file with :defmenu command.
  Menu entries are the pair: macro string.  String is a
  format string displayed in the menu.  Macro is executed
  when then menu entry is selected.
  Use this to add your own macros to ^T.
  - ^T is now a user definable menu system
  - Treat \ as a quote character for file I/O.  Now you can edit
    files like !test with \!test
  - Print NULs in default search string.  Handle many \s properly.
  - Allow backslashes in file names
  - Fix %%A to print unicode
  - Charles Tabony's (vectorshifts's) highlighter stack patch
  - ! is relace all in replace prompt
  - Turn off UTF-8 when we enter hex mode
  - Call ttsig on vfile I/O errors.
  - Abort cleanly when malloc returns NULL
  - Add reload command to reload file from disk
  - Modify configure scrips to use docdir for extra documents and
    datadir/joe for syntax and i18n files.
  - Don't use bold yellow, it's bad for white screens
  - Fix TeX highlighter: don't highlight "
  - Make mail.jsf more forgiving for those of us who still use old
    UNIX mail
  - Fix file rename bugs
  - Improve ubop: can reformat a block of paragraphs again.
    Reformat of adjacent indented paragraphs working again.
  - Improve XML highlighter: allow \r in whitespace
  Changes in 3.6:
  - Preserve setuid bit
  - Fix bug where backup file did not get modtime of original
  - New diff highlighter
  - Fix paragraph format when overtype is on
  - Fix non-french spacing
  - Fix bug with joe +2 on single line files
  - Add syntax file for .jsf files
  - Add ASCII table to joerc help
  - ^KD renames file
  - Improve HTML highlighter... if you see <? it's probably a script...
  - Check for EINTR from ioctl
  - > allowed in xml content
  - Add -flowed option: adds a space after paragraph lines.
  - Fix German and French .po files: they were cause search&replace to break.
  - Look at LC_MESSAGES to get the language to use for editor messages.
  - Added -no_double_quoted and -tex_comment for TeX
  - Added -break_symlinks option and changed -break_links option to not
    break symbolic links.
  - Paragraph format of single line paragraph is indented only if autoindent
    is enabled.
  - Guessindent no longer overrides istep if indendation is space.
  - Fix low limit of lmargin
  - Allow inserting file in rectangle mode even if selected rectangle is
    zero-width.
  - .js is Javascript
  - Fix ^G in perl mode when you hit it on second brace in:
  {\'
  \'}
  - Fix LUA highlighter
  - Improved conf.jsf
  - Added local option (-nobackup) to suppress backup files
  - Add Matlab syntax file
  - Improve mail syntax highlighter
  - Fix crash when calling syntax file as subroutine
  - Get "ctags" tag search to work again
  - Fix crash when JOE tries to write to unwritable file
  - Fix crash when entering blank macro ESC x <return>
  - Improve Verilog highlighter
  - Fix crash when typing ESC x !ls
  - Add C++ keywords to highlighter
  - Added RPM spec file syntax spec.jsf
  - Improve 'istring' (.jsf command)
  - Update French .po file
  - Fix infinite search/replace loop bug
  - New feature: insert status line format string using 'txt'
  - Update Russion .po file
  - Update Russian manpage
  - Update jicerc Russian rc file
  - Fix lock prompt message
  - Add Ukrainian .po file
* Fri Apr  4 2008 pnemec@suse.cz
- change rpm spec file color #333570 (dim white -> magenta)
* Sat Jun 23 2007 pth@suse.de
- Add a germen translation by Jan Engelhardt that doesn't break hotkeys.
- Patch by Jan Engelhardt to fix handling of locale categories.
* Mon Apr  2 2007 cthiel@suse.de
- added BuildRequires: ncurses-devel
* Sat Jul 22 2006 cthiel@suse.de
- update to 3.5
  * Fix $# in shell highlighter.
  * Fix .in files in ftype
  * Tags file patch: allows you to put a path in TAGS environment variable.
  * Fix possible querysave bug.
  * Fix query window bug: cursor was not left in original windows for new
    multi-line query window thing.
  * Fix bug where we could not find ^@
  * Accept ,start,size notation only if it is correct.
  * Fix bug from undo_keep: undo_keep has to be a multiple of 2 for redo to
    work properly.
  * New undo_keep option.
  * Add built-in joerc file.
  * Fix menu bug: coredump on left arrow.
  * allow |comments| in gettext strings.
  * dnelson's patches for large files, tty.c include file problems and
    $(srcdir).
  * new syntax files: m4 joerc
  * use hash table in rc file parser.
  * use hash table in syntax parser.
  * add auto-expanding hash table.
  * i18n of other single-key prompts.  add joe_gettext to yncheck.
  * fix bug coredump when doing multi-file search and replace
  * internationalized y/n handling.
  * new spell check macro which uses 'language'
  * fix sh highlight bug: do not try to highlight $( )
  * query windows can now be multi-line.  Also they should handle wide
    characters properly.
  * you can now type a macro right into the ESC X prompt.
  * New * Startup Log * window catches .jsf file errors.
* Tue May 30 2006 cthiel@suse.de
- update to 3.4
  * Paragraph reformatter and word wrap now handle '*' and '-' bullet lists.
  * Better internationalization (i18n)
  * Multi-file search and replace
  * Build and grep window work more like Turbo-C: the messages window is
    forced onto the screen when you hit ^[ = and ^[ -.
  * Syntax highlighter definition files (.jsf files) can now have
    subroutines.  This eases highlighter reuse: for example, Mason and PHP
    can share the HTML highlighter.
  * You can now define which characters can indent paragraphs.  Also the
    default list has been reduced so that formatting of TeX/LaTeX files
    works better.
  * Highlighting now uses less CPU time and always parses from the beginning
    of the file (the number of sync lines option is deprecated).
  * File selection menu/completion-list is now above the prompt (which is
    more like bash).  Also it is transposed, so that it is sorted by columns
    instead of rows.
  * "Bufed" (prompt for a buffer to edit), works like other file prompt
    commands: it's a real prompt with history and completion.
  * Automatic horizontal left scroll jumps by 5-10 columns.
  * New syntax files: troff, Haskell, Cadance SKILL, REXX, LUA, RUBY.  Many
    of the existing syntax files have been improved.
- removed joe-3.0-processing.patch, joe-3.1-compilesubdir.patch,
  joe-3.1-syntaxsegv.patch
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Jan 13 2006 schwab@suse.de
- Don't strip binaries.
* Tue Jul  5 2005 uli@suse.de
- build with warnings
- fixed warnings Autobuild objects to (fixes s390x)
* Sun Jun  5 2005 cthiel@suse.de
- update to 3.3
- disabled joe-3.1-compilesubdir.patch
* Wed Jun 23 2004 uli@suse.de
- parse entering/leaving dir msgs from make
* Thu Jun 17 2004 uli@suse.de
- update -> 3.1
* Tue Apr 27 2004 uli@suse.de
- fixed segfault in syntax highlighting
- added highlighting rules for spec files
* Mon Apr 26 2004 uli@suse.de
- update -> 3.0 (UTF-8 support, syntax highlighting)
* Sat Jan 10 2004 adrian@suse.de
- build as user
* Tue Feb  5 2002 egmont@suselinux.hu
- updated to 2.9.8-pre1
* Mon Jan 28 2002 egmont@suselinux.hu
- disabled undo patch, seems to be very buggy
- use relative symlinks instead of absolute ones
- added symlinks for manpages
- added URL
- added defattr(-,root,root) to spec file
* Wed Sep 26 2001 pmladek@suse.cz
- fixed problem with large files (#5833)
  * fixed by joe-2.9.7-pre1
* Thu Sep 13 2001 pmladek@suse.cz
- added three patches from SourceForge, thanks to
  Koblinger Egmont <egmont@suselinux.hu> for hints
  * resize - solves pause after xterm resizing
  * asis - turns off -asis in the default config, as it
    is no longer needed
  * undo - solves a problem with undo and the "Modified" mark
    after many savings
* Fri Aug 10 2001 pmladek@suse.cz
- downgraded to stable version 2.9.5
  * thanks to Koblinger Egmont <egmont@suselinux.hu> and
  his experiences
* Thu Jul 19 2001 pmladek@suse.cz
- updated to version 2.9.6
- config files moved from /usr/lib to /etc
- cleaned up spec file
* Thu May 24 2001 pmladek@suse.cz
- fixed cast warnings on ia64
- fixed runnig on ia64:
  * The argument of the function isblank must be an unsigned
  char or EOF but the function brc sometimes returns MAXINT.
* Fri Mar 30 2001 uli@suse.de
- update -> 2.9.5 (all fixes are still there)
* Thu Mar 15 2001 pblaha@suse.cz
- add build root
* Wed Mar 14 2001 pblaha@suse.cz
- applied patch from Thomas Biege
- This patch protects a user to open a .joerc file,
- that doesn't belongs to him, in public writeable
- directories (like /tmp). Commands can be executed
- via .joerc.
* Fri Jun 23 2000 nadvornik@suse.cz
- added locale patch
- sorted
* Fri May 19 2000 schwab@suse.de
- conf.c: don't redeclare time on ia64
* Tue Apr  4 2000 dipa@suse.de
- a patch that take the resizing of a X terminal into consideration
  +#include <sys/ioctl.h> in tty.c
* Thu Mar  2 2000 kukuk@suse.de
- Move /usr/man -> /usr/share/man
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Tue Aug 24 1999 uli@suse.de
- added -fsigned-char to CFLAGS (PPC)
* Sat Jul 24 1999 garloff@suse.de
- Applied better security fix (w/o unlinking) from thomas@suse.de
* Tue Jul 20 1999 garloff@suse.de
- Additionally added unlink("DEADJOE");
* Tue Jul 20 1999 garloff@suse.de
- Checked in DEADJOE permissions security fix from thomas@suse.de
* Tue Feb  2 1999 ro@suse.de
- conf.c: don't redeclare time on alpha
* Mon Nov 23 1998 max@suse.de
- termcap support is broken with glibc2
  but ncurses seems to work now.
* Fri Sep 18 1998 max@suse.de
- applied Home/End key fix from joe to the other *rc files
* Mon Aug 10 1998 max@suse.de
- added some doc files to the file list
* Fri Dec 12 1997 max@suse.de
- using terminfo again for bugfix reasons
* Tue Oct 28 1997 max@suse.de
- cleaned up generated specfile
- configured for terminfo instead of termcap
- fixed the Home/End key bug
